# __gnu_parallel::LoserTreeUnguardedBase< T, Comparator > Class Template Reference

Base class for unguarded LoserTree implementation. More...

Inheritance diagram for __gnu_parallel::LoserTreeUnguardedBase< T, Comparator >:

List of all members.

## Public Member Functions

- int get_min_source ()
- void insert_start (const T &key, int source, bool)
- LoserTreeUnguardedBase (unsigned int _k, const T _sentinel, Comparator _comp=std::less< T >())

## Protected Attributes

- Comparator comp
- unsigned int ik
- unsigned int k
- Loser * losers
- unsigned int offset

## Detailed Description

### template<typename T, typename Comparator>
class __gnu_parallel::LoserTreeUnguardedBase< T, Comparator >

Base class for unguarded LoserTree implementation.

The whole element is copied into the tree structure.

No guarding is done, therefore not a single input sequence must run empty. Unused sequence heads are marked with a sentinel which is > all elements that are to be merged.

This is a very fast variant.

Definition at line 554 of file losertree.h.

The documentation for this class was generated from the following file:

- losertree.h